<template src="./template.html"></template>

<script lang="ts">
import { getModule } from "nuxt-property-decorator";
import { Vue, Component, Prop, Watch } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import { api } from "~/common/constaint";
import AdminCollectionModule from "~/store/adminCollection";
import _, { chunk, cloneDeep, forEach, uniq, uniqBy } from "lodash";
import { api_key_tiny_editor } from "@/common/constaint";

const slugify = require("slugify");

@Component({
  components: {
    MediaPicker: () => import("@/components/Seller/Store/Gallery/index.vue"),
  },
})
export default class SettingSellerVariantsStoreComponent extends Vue {
  api_key_tiny_editor = api_key_tiny_editor;
  adminCollection = getModule(AdminCollectionModule, this.$store);

  dialogMediaPicker = false;
  limitImage = true;
  isSelectMultipleImage = false;

  imageVariant = {
    imageId: "",
    imageUrl: "",
  };
  isImageVariant = false;
  indexImageVariant: any = null;

  // listVariant: any = [];
  listVariantSelected = [];
  dialgoEditVariant = false;

  variant = {
    price: 0,
    comparePrice: 0,
    // productCost: 0,
    // fullfillmentCost: 0,
  };

  variantId = "";

  imageId = "";

  nameSelect: any = [];
  isSetMultipleImg = false;

  get listVariant() {
    const listVariantSellerId = cloneDeep(
      this.$store.state.sellerStore?.store?.product?.listVariantSellerId || []
    );
    for (let item of listVariantSellerId) {
      item["name"] = item.listValue[0];
    }
    return listVariantSellerId;
  }

  get listVariantOption() {
    const listVariantSellerId = cloneDeep(
      this.$store.state.sellerStore?.store?.product?.listVariantSellerId || []
    );
    return listVariantSellerId.length ? listVariantSellerId[0]?.listOption : [];
  }

  onSetVariant() {
    this.$store.commit("sellerStore/setStoreProduct", {
      listVariantSellerId: this.listVariant,
    });
  }

  async onSaveVariant(variant: any) {
    try {
      const body = {
        price: variant.price,
        comparePrice: variant.comparePrice,
        imageId: variant.imageId._id,
      };
      await this.$api.store.updateVariant(this.storeId, variant._id, body);
      this.$pushNotification.success("Update variant successfully");
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  selectActive(item: string) {
    const findItem = this.nameSelect.find((elem: any) => elem === item);
    if (findItem) return true;
    return false;
  }

  onHandleVariantSelect(type: string) {
    if (type === "all") {
      this.listVariantIds = this.listVariant.map((item: any) => item.name);
      this.selectedAllVariant = true;
    } else if (type === "none") {
      this.selectedAllVariant = false;
      this.listVariantIds = [];
      this.nameSelect = [];
    }
  }
  onHandleVariantSelected(item: any) {
    this.listVariantIds = [];
    this.listNameSelect = [];
    const findIdxName = this.nameSelect.findIndex((elem: any) => elem === item);
    if (findIdxName === -1) {
      this.nameSelect.push(item);
    } else {
      this.nameSelect.splice(findIdxName, 1);
    }
    for (let i = 0; i < this.listVariantOption.length; i++) {
      const list = this.listVariantOption[i].values.filter((value: any) =>
        this.nameSelect.includes(value)
      );
      this.listNameSelect.push({ i, values: list });
    }
    this.listNameSelect = this.listNameSelect.filter(
      (item: any) => item.values.length
    );
    this.onParseListVariantSelect();
    let listVariant = [];
    for (let elem of this.listVariant) {
      const listName = elem.listValue;
      listVariant.push(listName);
    }
    let listFoundFinal: any = [];
    for (const listSelectFind of this.resultArraySelect) {
      const listFound = listVariant.filter((variant) => {
        return listSelectFind.every((element: any) =>
          variant.includes(element)
        );
      });
      listFoundFinal = listFoundFinal.concat(listFound);
    }
    for (let item of listFoundFinal) {
      this.listVariantIds.push(item.join(" / "));
    }
  }

  resultArraySelect: any = [];
  listNameSelect: any = [];

  onParseListVariantSelect() {
    if (this.listNameSelect.length > 1) {
      let arr = this.listNameSelect.map((item: any) => chunk(item.values, 1));
      this.resultArraySelect = [];
      for (let i = 0; i < arr.length; i++) {
        let handleArray = arr[i];
        const gop = this.gop2mang(this.resultArraySelect, handleArray);
        this.resultArraySelect = [...gop];
      }
    } else {
      this.resultArraySelect = [];
      if (
        this.listNameSelect[0] &&
        this.listNameSelect[0].values.length === 1
      ) {
        this.resultArraySelect = [this.listNameSelect[0].values];
      } else if (
        this.listNameSelect[0] &&
        this.listNameSelect[0].values.length > 1
      ) {
        this.resultArraySelect = this.listNameSelect[0].values.map(
          (item: any) => [item]
        );
      } else {
        this.resultArraySelect = [];
      }
    }
  }

  gop2mang(array1: any, array2: any) {
    let arrColorSize = [];
    if (!array1.length) return array2;
    for (let color of array1) {
      for (let size of array2) {
        const variant = color;
        const variantTwo = size;
        arrColorSize.push([...variant, ...variantTwo]);
      }
    }
    return arrColorSize;
  }

  mounted() {
    this.storeId = this.$route.params.id || "";
  }
  openDialogMediaPicker(variant: any) {
    this.variantId = variant._id;
    this.dialogMediaPicker = true;
    this.isImageVariant = true;
    this.limitImage = true;
    this.imageId = variant?.imageId?._id || variant?.imageId || "";
  }

  resultArray: any = [];
  storeId = "";
  // End variant

  resetContent = false;

  config = {
    page: 1,
    limit: 25,
    search: "",
  };
  totalPage: number = 0;

  loadingTable = false;
  // selectedAll = false;
  selectedAllVariant = false;

  listVariantIds: any = [];
  listVariantProduct: any = [];

  imageRender = "";
  loading = false;

  variantIdx = "";
  tiptapWord = "";
  imageAdd = "";
  beforeDestroy() {
    this.$store.commit("adminCollection/setCoverId", {
      coverId: "",
      imageUrl: "",
    });
  }

  get imageUrl() {
    return this.$store.state.adminCollection.imageUrl;
  }
  onSelectImage(isImageVariant?: any) {
    this.limitImage = true;
    this.tiptapWord = "";
    this.dialogMediaPicker = true;
    if (isImageVariant === "isImageVariant") {
      this.isImageVariant = true;
      this.isSetMultipleImg = true;
      // this.indexImageVariant = idx;
    }
  }

  openDialogEditVariant() {
    this.dialgoEditVariant = true;
    if (this.listVariantIds.length) {
      const findVariant = this.listVariant.find(
        (item: any) => item.name === this.listVariantIds[0]
      );
      if (findVariant) {
        const {
          price,
          comparePrice,
          productCost,
          fullfillmentCost,
          // stock,
          sku,
        } = findVariant;
        this.variant = {
          price,
          comparePrice,
          // productCost,
          // fullfillmentCost,
          // stock,
        };
      }
    }
  }

  onEditVariant() {
    this.listVariantIds.forEach((id: string) => {
      this.listVariant.forEach((variant: any) => {
        if (id === variant.listValue.join(" / ")) {
          variant.price = this.variant.price;
          variant.comparePrice = this.variant.comparePrice;
          // variant.productCost = this.variant.productCost;
          // variant.fullfillmentCost = this.variant.fullfillmentCost;
          // variant.stock = this.variant.stock;
        }
      });
    });
    this.$store.commit("sellerStore/setStoreProduct", {
      listVariantSellerId: this.listVariant,
    });
    this.dialgoEditVariant = false;
    this.variant = {
      price: 0,
      comparePrice: 0,
      // productCost: 0,
      // fullfillmentCost: 0,
      // stock: 0,
    };
  }

  removeImage() {
    const listCoverId = cloneDeep(this.$store.state.adminGallery.listCoverId);
    listCoverId.splice(0, 1);
    this.$store.commit("adminGallery/setListCoverId", listCoverId);
  }

  calcPrice(product: any) {
    let price = 0;
    if (product.variant.length) {
      for (let variant of product.variant) {
        price += variant.price;
      }
    } else {
      return product.price;
    }
    return Math.round(price * 100) / 100;
  }
  convertImage(url: string) {
    return `${api}/${url}`;
  }
  convertMultipleImage(cover: any) {
    if (cover.imageUrl) {
      return `${api}/${cover.imageUrl}`;
    }
    return "";
  }
  convertImg(product: any) {
    if (product?.coverId?.imageUrl) {
      return `${api}/${product.coverId.imageUrl}`;
    }
    return "";
  }

  get listCoverId() {
    const listCoverId = cloneDeep(this.$store.state.adminGallery.listCoverId);
    return listCoverId && listCoverId.splice(1);
  }

  removeAccents(str: string) {
    return str
      .normalize("NFD")
      .replace(/[\u0300-\u036f]/g, "")
      .replace(/đ/g, "d")
      .replace(/Đ/g, "D");
  }

  @Watch("isImageVariant")
  changedIsImageVariant(value: boolean) {
    if (!value) {
      const listVariantSellerId = cloneDeep(this.listVariant);
      if (!this.listVariantIds.length) {
        listVariantSellerId.forEach((item: any) => {
          if (this.variantId === item._id) {
            if (item.imageId._id) {
              item.imageId._id = this.imageVariant.imageId;
              item.imageId.imageUrl = this.imageVariant.imageUrl;
            }
          }
        });
      } else {
        listVariantSellerId.forEach((item: any) => {
          const findIndex = this.listVariantIds.findIndex(
            (elem: any) => elem === item.listValue.join(" / ")
          );
          if (findIndex >= 0) {
            item.imageId._id = this.imageVariant.imageId;
            item.imageId.imageUrl = this.imageVariant.imageUrl;
          }
        });
      }
      this.$nextTick(() => {
        this.$store.commit("sellerStore/setStoreProduct", {
          listVariantSellerId: listVariantSellerId,
        });
      });
      this.isSelectMultipleImage = false;
      this.imageVariant = {
        imageId: "",
        imageUrl: "",
      };
    }
  }

  @Watch("selectedAllVariant")
  async onSelectAllVariantChanged(value: string, oldValue: string) {
    if (value) {
      const listVariantIds = [...this.listVariantIds];
      const selectedCurrentVariant = this.listVariant
        .map((item: any) => item.listValue.join(" / "))
        .filter((name: any) => !listVariantIds.includes(name));
      this.listVariantIds = [...listVariantIds, ...selectedCurrentVariant];
    } else {
      const selectedCurrentVariant = this.listVariant.map((item: any) =>
        item.listValue.join(" / ")
      );
      this.listVariantIds = this.listVariantIds.filter(
        (c: any) => !selectedCurrentVariant.includes(c)
      );
    }
  }
}
</script>
<style lang="css">
.border-variant {
  border: 1px solid #c3c3c3;
}

.isActive {
  background: #0ab54e;
  color: #ffffff;
}
</style>
